package cz.jzitnik.game.items;

import cz.jzitnik.game.Block;
import cz.jzitnik.game.SpriteLoader;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.Objects;
import java.util.Optional;

@Getter
@AllArgsConstructor
public class Item {
    private String name;
    private ItemType type;
    private Optional<ToolVariant> toolVariant = Optional.empty();
    private SpriteLoader.SPRITES sprite;
    private boolean stackable = true;
    private int durability;
    private int miningDecrease = 0;
    private Optional<Block> block;

    public Item(String name, ItemType type, SpriteLoader.SPRITES sprite, Block block) {
        this.name = name;
        this.type = type;
        this.sprite = sprite;
        this.block = Optional.of(block);
    }

    public void use() {
        durability--;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Item item = (Item) o;
        return stackable == item.stackable &&
                durability == item.durability &&
                miningDecrease == item.miningDecrease &&
                Objects.equals(name, item.name) &&
                type == item.type &&
                Objects.equals(sprite, item.sprite);
    }
}
